/**
 * generated by Xtext 2.25.0
 */
package org.xtext.example.methodname.generator;

import com.google.common.base.Objects;
import com.google.common.collect.Iterables;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.xtend2.lib.StringConcatenation;
import org.eclipse.xtext.generator.AbstractGenerator;
import org.eclipse.xtext.generator.IFileSystemAccess2;
import org.eclipse.xtext.generator.IGeneratorContext;
import org.eclipse.xtext.xbase.lib.Exceptions;
import org.eclipse.xtext.xbase.lib.IteratorExtensions;
import org.xtext.example.methodname.methodName.And;
import org.xtext.example.methodname.methodName.CardinalityModifier;
import org.xtext.example.methodname.methodName.Case;
import org.xtext.example.methodname.methodName.Declaration;
import org.xtext.example.methodname.methodName.Expr;
import org.xtext.example.methodname.methodName.Frequency;
import org.xtext.example.methodname.methodName.GroupExpr;
import org.xtext.example.methodname.methodName.Kind;
import org.xtext.example.methodname.methodName.Model;
import org.xtext.example.methodname.methodName.Or;
import org.xtext.example.methodname.methodName.POS;
import org.xtext.example.methodname.methodName.POSValue;
import org.xtext.example.methodname.methodName.Property;
import org.xtext.example.methodname.methodName.Rule;
import org.xtext.example.methodname.methodName.Sentiment;
import org.xtext.example.methodname.methodName.StringConst;
import org.xtext.example.methodname.methodName.SynonymConst;

@SuppressWarnings("all")
public class MethodNameGenerator extends AbstractGenerator {
  public Kind getPath(final Kind pathKind) {
    return pathKind;
  }
  
  public String operatorToString(final String operator) {
    String _switchResult = null;
    if (operator != null) {
      switch (operator) {
        case ">":
          _switchResult = "GT";
          break;
        case "<":
          _switchResult = "LT";
          break;
        case "==":
          _switchResult = "EQ";
          break;
        case "<=":
          _switchResult = "LE";
          break;
        case ">=":
          _switchResult = "GE";
          break;
        case "!=":
          _switchResult = "NE";
          break;
      }
    }
    return _switchResult;
  }
  
  @Override
  public void doGenerate(final Resource resource, final IFileSystemAccess2 fsa, final IGeneratorContext context) {
    Iterable<Model> _filter = Iterables.<Model>filter(IteratorExtensions.<EObject>toIterable(resource.getAllContents()), Model.class);
    for (final Model e : _filter) {
      fsa.generateFile("generatedRequirements.xml", 
        this.compile(e));
    }
  }
  
  public CharSequence compile(final Model m) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("<model>");
    _builder.newLine();
    {
      EList<Rule> _rules = m.getRules();
      for(final Rule r : _rules) {
        _builder.append("\t    ");
        CharSequence _compile = this.compile(r);
        _builder.append(_compile, "\t    ");
        _builder.newLineIfNotEmpty();
      }
    }
    {
      EList<Case> _elements = m.getElements();
      for(final Case c : _elements) {
        _builder.append("\t    ");
        CharSequence _compile_1 = this.compile(c);
        _builder.append(_compile_1, "\t    ");
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("</model>");
    _builder.newLine();
    return _builder;
  }
  
  public CharSequence compile(final Rule r) {
    StringConcatenation _builder = new StringConcatenation();
    {
      String _name = r.getName();
      boolean _notEquals = (!Objects.equal(_name, "callMethodWithSameName"));
      if (_notEquals) {
        _builder.append("<declare rule=\"");
        String _name_1 = r.getName();
        _builder.append(_name_1);
        _builder.append("\" for=\"");
        Kind _path = this.getPath(r.getKind());
        _builder.append(_path);
        _builder.append("\" op=\"");
        String _operatorToString = this.operatorToString(r.getCompOp());
        _builder.append(_operatorToString);
        _builder.append("\" size=\"");
        int _compValue = r.getCompValue();
        _builder.append(_compValue);
        _builder.append("\">");
        _builder.newLineIfNotEmpty();
        {
          EList<Declaration> _decls = r.getDecls();
          for(final Declaration d : _decls) {
            _builder.append("\t");
            _builder.append("<filter instance=\"");
            String _path_1 = d.getPath();
            _builder.append(_path_1, "\t");
            _builder.append("\"/>");
            _builder.newLineIfNotEmpty();
          }
        }
        _builder.append("</declare>");
        _builder.newLine();
      }
    }
    return _builder;
  }
  
  public CharSequence compile(final Case c) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("<case ");
    Kind _kind = c.getKind();
    _builder.append(_kind);
    _builder.append("=\"");
    CharSequence _compile = this.compile(c.getCondition());
    _builder.append(_compile);
    _builder.append("\">");
    _builder.newLineIfNotEmpty();
    {
      EList<Property> _properties = c.getProperties();
      for(final Property p : _properties) {
        CharSequence _compile_1 = this.compile(p);
        _builder.append(_compile_1);
        _builder.newLineIfNotEmpty();
      }
    }
    _builder.append("</case>");
    _builder.newLine();
    return _builder;
  }
  
  protected CharSequence _compile(final Expr e) {
    try {
      CharSequence _switchResult = null;
      boolean _matched = false;
      if (e instanceof Or) {
        _matched=true;
        StringConcatenation _builder = new StringConcatenation();
        _builder.append("(");
        CharSequence _compile = this.compile(((Or)e).getLeft());
        _builder.append(_compile);
        _builder.append("|");
        CharSequence _compile_1 = this.compile(((Or)e).getRight());
        _builder.append(_compile_1);
        _builder.append(")");
        _switchResult = _builder;
      }
      if (!_matched) {
        if (e instanceof And) {
          _matched=true;
          StringConcatenation _builder = new StringConcatenation();
          _builder.append("(");
          CharSequence _compile = this.compile(((And)e).getLeft());
          _builder.append(_compile);
          _builder.append(".");
          CharSequence _compile_1 = this.compile(((And)e).getRight());
          _builder.append(_compile_1);
          _builder.append(")");
          _switchResult = _builder;
        }
      }
      if (!_matched) {
        if (e instanceof GroupExpr) {
          _matched=true;
          StringConcatenation _builder = new StringConcatenation();
          _builder.append("(");
          CharSequence _compile = this.compile(((GroupExpr)e).getExpr());
          _builder.append(_compile);
          {
            CardinalityModifier _card = ((GroupExpr)e).getCard();
            boolean _notEquals = (!Objects.equal(_card, CardinalityModifier.CARD_1));
            if (_notEquals) {
              CardinalityModifier _card_1 = ((GroupExpr)e).getCard();
              _builder.append(_card_1);
            }
          }
          _builder.append(")");
          _switchResult = _builder;
        }
      }
      if (!_matched) {
        if (e instanceof StringConst) {
          _matched=true;
          StringConcatenation _builder = new StringConcatenation();
          _builder.append("(");
          String _value = ((StringConst)e).getValue();
          _builder.append(_value);
          {
            Sentiment _sentiment = ((StringConst)e).getSentiment();
            boolean _equals = Objects.equal(_sentiment, Sentiment.SENT_UNSPECIFIED);
            if (_equals) {
              _builder.append("@positive | ");
              String _value_1 = ((StringConst)e).getValue();
              _builder.append(_value_1);
              _builder.append("@negative | ");
              String _value_2 = ((StringConst)e).getValue();
              _builder.append(_value_2);
              _builder.append("@neutral");
            } else {
              _builder.append("@");
              Sentiment _sentiment_1 = ((StringConst)e).getSentiment();
              _builder.append(_sentiment_1);
            }
          }
          _builder.append(")");
          {
            CardinalityModifier _card = ((StringConst)e).getCard();
            boolean _notEquals = (!Objects.equal(_card, CardinalityModifier.CARD_1));
            if (_notEquals) {
              CardinalityModifier _card_1 = ((StringConst)e).getCard();
              _builder.append(_card_1);
            }
          }
          _switchResult = _builder;
        }
      }
      if (!_matched) {
        if (e instanceof POSValue) {
          _matched=true;
          StringConcatenation _builder = new StringConcatenation();
          _builder.append("(");
          POS _pos = ((POSValue)e).getPos();
          _builder.append(_pos);
          {
            Sentiment _sentiment = ((POSValue)e).getSentiment();
            boolean _equals = Objects.equal(_sentiment, Sentiment.SENT_UNSPECIFIED);
            if (_equals) {
              _builder.append("@positive | ");
              POS _pos_1 = ((POSValue)e).getPos();
              _builder.append(_pos_1);
              _builder.append("@negative | ");
              POS _pos_2 = ((POSValue)e).getPos();
              _builder.append(_pos_2);
              _builder.append("@neutral");
            } else {
              _builder.append("@");
              Sentiment _sentiment_1 = ((POSValue)e).getSentiment();
              _builder.append(_sentiment_1);
            }
          }
          _builder.append(")");
          {
            CardinalityModifier _card = ((POSValue)e).getCard();
            boolean _notEquals = (!Objects.equal(_card, CardinalityModifier.CARD_1));
            if (_notEquals) {
              CardinalityModifier _card_1 = ((POSValue)e).getCard();
              _builder.append(_card_1);
            }
          }
          _switchResult = _builder;
        }
      }
      if (!_matched) {
        if (e instanceof SynonymConst) {
          _matched=true;
          StringConcatenation _builder = new StringConcatenation();
          {
            Sentiment _sentiment = ((SynonymConst)e).getSentiment();
            boolean _equals = Objects.equal(_sentiment, Sentiment.SENT_UNSPECIFIED);
            if (_equals) {
              _builder.append("(");
              String _generateAllSynonyms = Synonym.generateAllSynonyms(((SynonymConst)e).getValue(), "unspecified");
              _builder.append(_generateAllSynonyms);
            } else {
              Sentiment _sentiment_1 = ((SynonymConst)e).getSentiment();
              boolean _equals_1 = Objects.equal(_sentiment_1, Sentiment.SENT_NEUTRAL);
              if (_equals_1) {
                _builder.append("(");
                String _generateAllSynonyms_1 = Synonym.generateAllSynonyms(((SynonymConst)e).getValue(), Sentiment.SENT_NEUTRAL.toString());
                _builder.append(_generateAllSynonyms_1);
              } else {
                Sentiment _sentiment_2 = ((SynonymConst)e).getSentiment();
                boolean _equals_2 = Objects.equal(_sentiment_2, Sentiment.SENT_POSITIVE);
                if (_equals_2) {
                  _builder.append("(");
                  String _generateAllSynonyms_2 = Synonym.generateAllSynonyms(((SynonymConst)e).getValue(), Sentiment.SENT_POSITIVE.toString());
                  _builder.append(_generateAllSynonyms_2);
                } else {
                  Sentiment _sentiment_3 = ((SynonymConst)e).getSentiment();
                  boolean _equals_3 = Objects.equal(_sentiment_3, Sentiment.SENT_NEGATIVE);
                  if (_equals_3) {
                    _builder.append("(");
                    String _generateAllSynonyms_3 = Synonym.generateAllSynonyms(((SynonymConst)e).getValue(), Sentiment.SENT_NEGATIVE.toString());
                    _builder.append(_generateAllSynonyms_3);
                  }
                }
              }
            }
          }
          _builder.append(")");
          {
            CardinalityModifier _card = ((SynonymConst)e).getCard();
            boolean _notEquals = (!Objects.equal(_card, CardinalityModifier.CARD_1));
            if (_notEquals) {
              CardinalityModifier _card_1 = ((SynonymConst)e).getCard();
              _builder.append(_card_1);
            }
          }
          _switchResult = _builder;
        }
      }
      return _switchResult;
    } catch (Throwable _e) {
      throw Exceptions.sneakyThrow(_e);
    }
  }
  
  public CharSequence compile(final Property p) {
    StringConcatenation _builder = new StringConcatenation();
    _builder.append("<");
    Frequency _frequency = p.getFrequency();
    _builder.append(_frequency);
    _builder.append("><");
    String _name = p.getCriterion().getName();
    _builder.append(_name);
    _builder.append("/></");
    Frequency _frequency_1 = p.getFrequency();
    _builder.append(_frequency_1);
    _builder.append(">");
    _builder.newLineIfNotEmpty();
    return _builder;
  }
  
  public CharSequence compile(final Expr e) {
    return _compile(e);
  }
}
